View Issue Details

IDProjectCategoryView StatusLast Update
0002350Far ManagerFile Systempublic2013-04-18 15:40
ReporterivfgsAssigned Toalexy 
PrioritynormalSeveritymajorReproducibilityalways
Status closedResolutionfixed 
Platformx86OSWindowsOS Version7
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0002350: Притормаживает при доступе по Samba к Android.
DescriptionМобила на Android 4.1.1, в ней флешка, которая расшарена через приложение "SambaDroid" для доступа к ней с PC с Windows 7 и Far30b3258.x86.20130320. При перемещении по дереву каталогов притормаживает.

Полезная информация:
  - первый уровень работает быстро, но чем длиннее становится путь, тем больше задержка при входе/выходе из очередной папки; если названия папок на русском то еще медленнее
  - аналогично со второго PC (с таким же ПО)
  - PC1 - PC2 все быстро
  - с плеера Dune все быстро
  - Windows Explorer тоже притормаживал, но перестал после добавления DWORD TcpAckFrequency=1 в HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\Tcpip\Parameters\Interfaces\<адаптер>, Far Manager при этом не перестал...
  - Network drives autorefresh влияет, но проблема остается
  - антивирусы, фаерволы, сетевые привязки отключать пробовал

А т.к. перемещение по каталогам это одна из основных операций в файловых менеджерах, то получается что лишние пару секунд на каждом щелчке мышкой в результате в несколько раз замедляют общую работу.
TagsNo tags attached.
Build3348

Activities

alexy

2013-04-10 12:15

administrator   bugnote:0010708

Нужна запись ProcessMonitor одинакового хождения по папкам в Эксплорере и в Фаре.

ivfgs

2013-04-11 13:05

reporter  

Windows Explorer.7z (3,345,007 bytes)

ivfgs

2013-04-11 13:05

reporter  

Far Manager.7z (760,793 bytes)

ivfgs

2013-04-11 13:09

reporter   bugnote:0010729

Файлы приаттачил.
(С выключенным Network drives autorefresh.)

alexy

2013-04-11 15:46

administrator   bugnote:0010738

Хм, при каждом переходе папки мы сканируем почему то все папки от корня до той к которой надо перейти (CreateFile, QueryDirectory * N, CloseFile), ну и чем глубже папка тем больше таких "проходов".

DrKnS, тебе это не знакомо?

ivfgs, попробуй на всякий пожарный с самым свежим фаром.

alexy

2013-04-11 15:51

administrator   bugnote:0010739

Проверь если "Scan symbolic links" в system settings влияет на поведение.

DrKnS

2013-04-11 15:58

administrator   bugnote:0010740

Могу ошибаться, но похоже на защиту от рекурсивных симлинков.

alexy

2013-04-11 16:06

administrator   bugnote:0010741

А зачем вообще от них защищатся при переходе по папкам? (я понимаю ещё при поиске).

DrKnS

2013-04-11 17:22

administrator   bugnote:0010744

Не, я посмотрел - эта защита в scantree, это что-то другое.

Снова ткну пальцем в небо - PrepareDiskPath(), не?

alexy

2013-04-11 18:35

administrator   bugnote:0010749

Я тоже боюсь что это там, да.

ivfgs

2013-04-13 00:43

reporter   bugnote:0010761

Скачал ночную сборку, отключил "Scan symbolic links". Показалось что без изменений.

alexy

2013-04-14 00:48

administrator   bugnote:0010765

DrKnS, не знаешь зачем у нас вот такое?
            if (PanelMode==PLUGIN_PANEL || !CurPtr->strName.Contains(L'?') || CurPtr->strShortName.IsEmpty())
            {
                ChangeDir(CurPtr->strName,TRUE,CurPtr);
            }
            else
            {
                ChangeDir(CurPtr->strShortName,TRUE,CurPtr);
            }


Без этого можно бы было при Enter на панелях вызывать ChangeDir с флагом чтоб вызывал PrepareDiskPath(..., false) так как он не нужен в этом случае. Ы?

DrKnS

2013-04-14 13:32

administrator   bugnote:0010777

Подозреваю, это кто-то ещё в 1.7 запилил костыль, чтобы фар мог заходить в юникодную папку по короткому имени.

alexy

2013-04-14 15:20

administrator   bugnote:0010779

Проверяй в билде 3330.

ivfgs

2013-04-15 16:40

reporter   bugnote:0010783

Скачал Far30b3331, тормозит...

alexy

2013-04-15 17:00

administrator   bugnote:0010784

Прогони ProcMon ещё раз именно вот с этим фаром:
http://farmanager.com/farbugs/Debug.32.vc.7z

ivfgs

2013-04-15 20:16

reporter  

FarManager 15.04.7z (579,765 bytes)

ivfgs

2013-04-15 20:17

reporter   bugnote:0010785

готово

alexy

2013-04-15 22:00

administrator   bugnote:0010786

3334

ivfgs

2013-04-16 22:19

reporter  

Far Manager, autorefresh disabled.7z (305,835 bytes)

ivfgs

2013-04-16 22:19

reporter  

Far Manager, autorefresh enabled.7z (382,238 bytes)

ivfgs

2013-04-16 22:38

reporter   bugnote:0010803

Проверил на 3336, с отключенным autorefresh работать стало раза в три быстрее, с включенным все еще медленно. Оба варианта залил.
Windows Explorer же переходит вообще без задержки, причем с авторефрешем (моментально отображает созданную другой программой папку).

alexy

2013-04-16 23:15

administrator   bugnote:0010804

Т.е. без авторефреша теперь скорость удовлетворительная?

alexy

2013-04-16 23:26

administrator   bugnote:0010805

И собери всё заново с вот этим фаром, пожалуйста:
http://farmanager.com/farbugs/Debug.32.vc.3339.7z

ivfgs

2013-04-17 12:41

reporter  

Far Manager 17.04.7z (278,603 bytes)

ivfgs

2013-04-17 12:58

reporter   bugnote:0010810

Да, если без авторефреша удовлетворительная, спасибо :) См тж "Far Manager 17.04.7z".

Еще вспомнил момент с включенным авторефрешем: если ухожу с телефоном и соответственно доступ к шАрам на время пропадает, в уже открытых Far пути сбрасываются на C:, приходится потом проходить по ним заново.

alexy

2013-04-17 13:08

administrator   bugnote:0010815

На сброс путей открой отдельный тикет, это пока мне лично мало интересно, может кто то другой посмотрит.

alexy

2013-04-17 13:21

administrator   bugnote:0010816

А что именно в аттаче последнем? Там вроде авторефреша нету.
И что именно тормозит при авторефреше?

ivfgs

2013-04-17 19:17

reporter  

Far Manager 17.04 w autorefresh.PML.7z (391,383 bytes)

ivfgs

2013-04-17 19:28

reporter   bugnote:0010825

"А что именно в аттаче последнем? Там вроде авторефреша нету." - этот аттач относился к "И собери всё заново с вот этим фаром, пожалуйста". Т.к. настройки не менял, autorefresh был выключен.
Теперь аналогичный аттач со включенным.
"И что именно тормозит при авторефреше?" - просто щелкаешь на папке чтобы войти и секунду-две ждешь, т.е. так как было с отключенным autorefresh до исправлений.

alexy

2013-04-17 20:49

administrator   bugnote:0010827

3342, это максимум что пока что можно сделать малой кровью.
Дальше в общем только потоки и асинхронность.

alexy

2013-04-17 20:53

administrator   bugnote:0010828

Хотя, одну вещь можно сделать асинхронной довольно просто, должно сильно улучшить скорость. Завтра сделаю.

alexy

2013-04-18 12:48

administrator   bugnote:0010847

3348 должен по идеи и с авторефрешем работать нормально.

ivfgs

2013-04-18 15:38

reporter   bugnote:0010851

Ага, с авторефрешем теперь работает почти также как и без (около пол секунды).

Issue History

Date Modified Username Field Change
2013-03-26 09:35 ivfgs New Issue
2013-04-10 12:15 alexy Note Added: 0010708
2013-04-11 13:05 ivfgs File Added: Windows Explorer.7z
2013-04-11 13:05 ivfgs File Added: Far Manager.7z
2013-04-11 13:09 ivfgs Note Added: 0010729
2013-04-11 15:46 alexy Note Added: 0010738
2013-04-11 15:51 alexy Note Added: 0010739
2013-04-11 15:58 DrKnS Note Added: 0010740
2013-04-11 16:06 alexy Note Added: 0010741
2013-04-11 17:22 DrKnS Note Added: 0010744
2013-04-11 18:35 alexy Note Added: 0010749
2013-04-13 00:43 ivfgs Note Added: 0010761
2013-04-14 00:48 alexy Note Added: 0010765
2013-04-14 13:32 DrKnS Note Added: 0010777
2013-04-14 15:20 alexy Note Added: 0010779
2013-04-14 15:20 alexy Assigned To => alexy
2013-04-14 15:20 alexy Status new => feedback
2013-04-15 16:40 ivfgs Note Added: 0010783
2013-04-15 16:40 ivfgs Status feedback => assigned
2013-04-15 17:00 alexy Note Added: 0010784
2013-04-15 20:16 ivfgs File Added: FarManager 15.04.7z
2013-04-15 20:17 ivfgs Note Added: 0010785
2013-04-15 22:00 alexy Note Added: 0010786
2013-04-15 22:00 alexy Status assigned => feedback
2013-04-16 22:19 ivfgs File Added: Far Manager, autorefresh disabled.7z
2013-04-16 22:19 ivfgs File Added: Far Manager, autorefresh enabled.7z
2013-04-16 22:38 ivfgs Note Added: 0010803
2013-04-16 22:38 ivfgs Status feedback => assigned
2013-04-16 23:15 alexy Note Added: 0010804
2013-04-16 23:26 alexy Note Added: 0010805
2013-04-17 12:41 ivfgs File Added: Far Manager 17.04.7z
2013-04-17 12:58 ivfgs Note Added: 0010810
2013-04-17 13:08 alexy Note Added: 0010815
2013-04-17 13:21 alexy Note Added: 0010816
2013-04-17 19:17 ivfgs File Added: Far Manager 17.04 w autorefresh.PML.7z
2013-04-17 19:28 ivfgs Note Added: 0010825
2013-04-17 20:49 alexy Note Added: 0010827
2013-04-17 20:49 alexy Status assigned => feedback
2013-04-17 20:53 alexy Note Added: 0010828
2013-04-18 12:48 alexy Note Added: 0010847
2013-04-18 15:38 ivfgs Note Added: 0010851
2013-04-18 15:38 ivfgs Status feedback => assigned
2013-04-18 15:40 alexy Build => 3348
2013-04-18 15:40 alexy Status assigned => closed
2013-04-18 15:40 alexy Resolution open => fixed
2013-04-18 15:40 alexy Fixed in Version => 3.0